###
### This file is generated automatically by SALOME v6.3.1 with dump python functionality
###

import sys
import salome

salome.salome_init()
theStudy = salome.myStudy

import salome_notebook
notebook = salome_notebook.notebook
sys.path.insert( 0, r'/cae/caexample/solids/c01c10')

import iparameters
ipar = iparameters.IParameters(salome.myStudy.GetCommonParameters("Interface Applicative", 1))

#Set up visual properties:
ipar.setProperty("AP_ACTIVE_VIEW", "VTKViewer_0_0")
ipar.setProperty("AP_ACTIVE_MODULE", "Mesh")
ipar.setProperty("AP_SAVEPOINT_NAME", "GUI state: 1")
ipar.append("AP_MODULES_LIST", "Geometry")
ipar.append("AP_MODULES_LIST", "Mesh")


###
### GEOM component
###

import GEOM
import geompy
import math
import SALOMEDS


geompy.init_geom(theStudy)
Xmax = 2.5
Ymax = 6.0
P_0 = geompy.MakeVertex( 0,     0,    0)
P_1 = geompy.MakeVertex( Xmax,  Ymax, 0)
P_2 = geompy.MakeVertex( Xmax, -Ymax, 0)
P_3 = geompy.MakeVertex(-Xmax, -Ymax, 0)
P_4 = geompy.MakeVertex(-Xmax,  Ymax, 0)
P_z = geompy.MakeVertex(0, 0, 1)
Edge_1 = geompy.MakeEdge(P_4, P_1)
Edge_2 = geompy.MakeEdge(P_1, P_2)
Edge_3 = geompy.MakeEdge(P_2, P_3)
Edge_4 = geompy.MakeEdge(P_3, P_4)
Face_1 = geompy.MakeFaceWires([Edge_1, Edge_2, Edge_3, Edge_4], 1)
Vector_1 = geompy.MakeVector(P_0, P_z)
Gblock = geompy.MakePrismVecH(Face_1, Vector_1, 43)
listSubShapeIDs = geompy.SubShapeAllIDs(Gblock, geompy.ShapeType["FACE"])
Atop = geompy.CreateGroup(Gblock, geompy.ShapeType["FACE"])
geompy.UnionIDs(Atop, [33])
Abot = geompy.CreateGroup(Gblock, geompy.ShapeType["FACE"])
geompy.UnionIDs(Abot, [31])
Pbot = geompy.CreateGroup(Gblock, geompy.ShapeType["VERTEX"])
geompy.UnionIDs(Pbot, [0])
geompy.addToStudy( P_0, 'P_0' )
geompy.addToStudy( P_1, 'P_1' )
geompy.addToStudy( P_2, 'P_2' )
geompy.addToStudy( P_3, 'P_3' )
geompy.addToStudy( P_4, 'P_4' )
geompy.addToStudy( Edge_1, 'Edge_1' )
geompy.addToStudy( Edge_2, 'Edge_2' )
geompy.addToStudy( Edge_3, 'Edge_3' )
#geompy.addToStudyInFather( Edge_1, Edge_1_vertex_3, 'Edge_1:vertex_3' )
geompy.addToStudy( Edge_4, 'Edge_4' )
geompy.addToStudy( Face_1, 'Face_1' )
geompy.addToStudy( P_z, 'Pz' )
geompy.addToStudy( Vector_1, 'Vector_1' )
geompy.addToStudy( Gblock, 'Gblock' )
geompy.addToStudyInFather( Gblock, Atop, 'Atop' )
geompy.addToStudyInFather( Gblock, Abot, 'Abot' )

### Store presentation parameters of displayed objects
import iparameters
ipar = iparameters.IParameters(theStudy.GetModuleParameters("Interface Applicative", "GEOM", 1))

###
### SMESH component
###

import smesh, SMESH, SALOMEDS
import StdMeshers
import GHS3DPlugin
##import SMESH_mechanic


aMeasurements = smesh.CreateMeasurements()
smesh.SetCurrentStudy(theStudy)
smeshObj_1 = smesh.CreateHypothesis('GHS3D_Parameters', 'GHS3DEngine')
allEnforcedVertices = smeshObj_1.GetEnforcedVertices()
Quadrangle_Parameters_1 = smesh.CreateHypothesis('QuadrangleParams')
Quadrangle_Parameters_1.SetQuadType( StdMeshers.QUAD_STANDARD )
Mblock = smesh.Mesh(Gblock)
Regular_1D = Mblock.Segment()
Automatic_length_1 = Regular_1D.AutomaticLength(0.33)
Quadratic_Mesh_1 = Regular_1D.QuadraticMesh()
status = Mblock.AddHypothesis(Quadrangle_Parameters_1)
Quadrangle_2D = Mblock.Quadrangle()
Quadrangle_Preference_1 = Quadrangle_2D.QuadranglePreference()
Hexa_3D = smesh.CreateHypothesis('Hexa_3D')
status = Mblock.AddHypothesis(Hexa_3D)
isDone = Mblock.Compute()
Atop = Mblock.GroupOnGeom(Atop,'Atop',SMESH.FACE)
Abot = Mblock.GroupOnGeom(Abot,'Abot',SMESH.FACE)

x,y,z = 0.000,0.000,0.000
node000 = None
n = Mblock.FindNodeClosestTo(x,y,z)
if n == node000:
    print "No node found close to [0,0,0]: ",n
else:
    print "Node closest to [0,0,0]: ",n
xyz = Mblock.GetNodeXYZ(n)
print "Node will be moved in x,y,z: ",x-xyz[0],y-xyz[1],z-xyz[2]
NodeMoved = Mblock.MoveNode(n,x,y,z )
if not n:
    print "No node moved to [0,0,0]",n
    
print "Node moved: ",n,NodeMoved
Nfixx = Mblock.CreateEmptyGroup( SMESH.NODE, 'Nfixx' )
nbAdd = Nfixx.Add( [ n ] )
##isDone = Mblock.Compute()


node000 = None
ny1 = Mblock.FindNodeClosestTo(0.000, Ymax,0.000)
ny2 = Mblock.FindNodeClosestTo(0.000,-Ymax,0.000)
xyz1 = Mblock.GetNodeXYZ(ny1)
xyz2 = Mblock.GetNodeXYZ(ny2)
print "Node will be moved in x,y,z: ",x-xyz1[0],y-xyz1[1],z-xyz1[2]
print "Node will be moved in x,y,z: ",x-xyz2[0],y-xyz2[1],z-xyz2[2]
NodeMoved1 = Mblock.MoveNode(ny1,0.000, Ymax,0.0000)
NodeMoved2 = Mblock.MoveNode(ny2,0.000,-Ymax,0.0000)
print "Node moved: ",ny1,NodeMoved1,ny2,NodeMoved2

Nfixy = Mblock.CreateEmptyGroup( SMESH.NODE, 'Nfixy' )
nbAdd = Nfixy.Add( [ ny1,ny2 ] )
isDone = Mblock.Compute()

smesh.SetName(Quadrangle_Parameters_1, 'Quadrangle Parameters_1')
smesh.SetName(Mblock.GetMesh(), 'Mblock')
smesh.SetName(Regular_1D.GetAlgorithm(), 'Regular_1D')
smesh.SetName(Automatic_length_1, 'Automatic length_1')
smesh.SetName(Quadratic_Mesh_1, 'Quadratic Mesh_1')
smesh.SetName(Quadrangle_2D.GetAlgorithm(), 'Quadrangle_2D')
#smesh.SetName(Quadrangle_Preference_1, 'Quadrangle Preference_1')
smesh.SetName(Hexa_3D, 'Hexa_3D')
smesh.SetName(Atop, 'Atop')
smesh.SetName(Abot, 'Abot')

### Store presentation parameters of displayed objects
import iparameters
ipar = iparameters.IParameters(theStudy.GetModuleParameters("Interface Applicative", "SMESH", 1))



if salome.sg.hasDesktop():
  salome.sg.updateObjBrowser(1)
  iparameters.getSession().restoreVisualState(1)


